#include "socktools.h"

int startWS (void) {
   WORD wVersionRequested;          /* Version of Winsock to load */
   WSADATA wsaData;                 /* Winsock implementation details */

   wVersionRequested = MAKEWORD(2, 0);   /* Request Winsock v2.0 */
   if (WSAStartup(wVersionRequested, &wsaData) != 0) /* Load Winsock DLL */
   {
      fprintf(stderr,"WSAStartup() failed");
      return 0;
   }
   return 1;
}



char *recvLine(int sock, char *buf, int buflen) {

   char nb = '\0';
   int  cp = 0;
   int  r;

   while((r = recv(sock, &nb, 1, 0)) > 0) {
      //check for end
      if (nb == '\n') break;

      //add new byte
      if (nb == '\r') {
      } else {
         buf[cp] = nb;
         cp++;
      }

      //break if full buffer
      if (cp == buflen -1) break;
   }

   //put end on string
   buf[cp] = '\0';

   //check for err
   if (r < 0)   printf("Error in recvLine()\n");
   return ((cp == 0 && r < 0) ? NULL : buf);
}

int sendLine(int sock, const char *buf) {
   char *sb;
   int   i;
   i  = strlen(buf) + 3;
   sb = malloc(i);
   if (sb==NULL) return -1;
   sprintf(sb, "%s\r\n", buf);
   i = send(sock, sb, (i - 1), 0);
   free(sb);
   return i;
}


int serverSocket(int ip, short port) {
   int sock1;
   struct sockaddr_in servAddr;

   if ((sock1 = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
      printf("socket() err\n");
      return -1;
   }

   memset(&servAddr, 0, sizeof(struct sockaddr_in));
   servAddr.sin_family      = AF_INET;
   servAddr.sin_port        = htons(port);
   servAddr.sin_addr.s_addr = htonl(ip);

   if (bind(sock1, (struct sockaddr *)&servAddr, sizeof(struct sockaddr_in)) < 0) {
      printf("bind() err\n");
      closesocket(sock1);
      return -1;
   }

   if (listen(sock1, SOMAXCONN) < 0) {
      printf("listen() err\n");
      closesocket(sock1);
      return -1;
   }

   return sock1;
}




